#include <qscrollview.h>
#include <qdom.h>
#include "design/idxview.h"

class IdxViewItem: public QListBoxText {
public:
  int art_start, art_end;
  QString tstr;

  IdxViewItem *prevSibling, *nextSibling;
  IdxViewItem *firstChild;

  IdxViewItem( int start, int end, char *text );
  virtual QString text() const;
};

class IdxView: public IdxViewUI {
  Q_OBJECT
public:
  IdxView();
  void loadIndex( char *prefix );
  void loadIndexXML( char *prefix );
protected:
  QString fname, dfname;
  bool xmlMode;

  IdxViewItem *rootNode;
  IdxViewItem *lookupNode( IdxViewItem *from, QString prefix, int pfxlen );
  IdxViewItem *lookupNode( QString prefix );
  void insertNode( IdxViewItem *node );
  void dumpChilds( IdxViewItem *node, int indent );
  void dumpTree();

  QDomElement getXMLArticle( QString word );
public slots:
  void lookupByPrefix();
  void loadEnRu();
  void loadRuEn();
  void loadDefXML();
  void loadCustom();
  void showArticle( QListBoxItem *lbItem );
};

class ArticleView: Qt {
public:
  ArticleView();
  void loadArticle( char *fname, int start, int stop );
  void loadArticleXML( QDomElement e );
protected:
  QString transXMLtoRichText( QDomElement e );
};

